/*
Tiedosto: WebClientHandler.java
Luokat:   

Tekij:   Joni Karppinen
Luonti:   25.11.2002

Muutokset:  

4.12.   Joni
         Hahmoteltu / koodattu suurimmaksi osaksi
19.12.  Joni
        Javadocit, poistettu vanhentuneita osia
        Listty mahdollisuus mritell webcoren kyttmt portit asetustiedostossa

*/

package converge.clientmanager;
import converge.service.*;
import java.util.*;
import java.io.*;
import webcore.webserver.application.*;


/**
ClientHandler-luokan aliluokka, joka mahdollistaa WWW-selaimen kytn
asiakasohjemana. Jrjestelmss on vain yksi WebClientHandler-ilmentym.
<br><br>
(Tss prototyypiss WebClientHanderissa ei ole juuri mitn toiminallisuutta, 
vaan suurin osa asioista tehdn {@link webcore} -pakkauksen luokissa.)

@see webcore
*/
public class WebClientHandler extends ClientHandler{

    /**
    Viite jrjestelmn ainoaan ClientManager-olioon.
    (Ei tarvita tss toteutuksessa)
    */
    // private ClientManager cm;      

    /**
    Viite jrjestelmn ainoaan WebClientHandler-olioon.
    */
    private static WebClientHandler webClientHandler;
    
    
    /**
    Konstruktori        
    */
    private WebClientHandler(){        
    }

    /**
    Tietorakenne, jossa silytetn tietoa siit ett jollekin kyttjlle
    on uusia viestej.
       
    User => true/false
    [ei kytss tss toteutuksessa]
    */
    /*
    private HashMap pendingMessages;
    */
    

    /**
    Tekee tarvittavat kynnistys & alustustoimet,
    eli kynnist webcore -HTTP-palvelimen.    
    <br><br>    
    Osa webcoren parametreista on kovakoodattu thn metodiin, 
    porttinumerot luetaan asetustiedostosta (config/clientmanager.cfg).    
    */
    public void start(){    
        
    //  vastaava ksky komentorivill:    
    //  /opt/j2sdk1.4.1_01/bin/java -server webserver.application.WWWServerConsole
    //   public_html public_html converge.key moRyenI

        String[] args = new String[6];
        args[0] = "webcore/public_html";    // ei-SSL -dokumenttien polku
        args[1] = "webcore/public_html";    // SSL -dokumenttien polku
        args[2] = "config/converge.key";     // polku salausavaimeen
        args[3] = "moRyenI";                // salausavaimen salasana
        
        // luetaan asetustiedostosta porttinumerot
        Properties settings = new Properties();
        try{            
            settings.load(new FileInputStream(new File("config/clientmanager.cfg")));
        }
        catch (Exception e){
            System.out.println("WEBCLIENTANDLER.start: " + e);
            args[4] = "8080";
            args[5] = "8081";
        }
        
        args[4] = settings.getProperty("portnumber", "8080");
        args[5] = settings.getProperty("ssl-portnumber", "8081");        
                
        //webcore.webserver.application.WWWServerConsole.start();
        WWWServerConsole.main(args);   // kynnistetn webcore em. parametreilla            
    }
    
    /**
    ClientHandlerin alasajo. WebClientHandlerin (ja webcoren) tapauksessa ei tarvitse (vttmtt) tehd mitn.
    
    */
    public void shutdown() {
       ;
    }

    /** 
    Palauttaa ClientHandlerin tyypin
    
    @return ClientHandlerin tyyppi, vakio "WWW_CLIENT"
    */
    public String getType(){
        return     "WWW_CLIENT";
    }

    /**
    Viestien lhetyst ei tss luokassa toteuteta nyt mitenkn
    <br><br>
            
    */
    public void sendMessage(Message msg){
        /*
        User tmpUser = msg.getUser();
        pendingMessages.put(tmpUser, Boolean.valueOf(true));
        */
    }

    /**
    WWW-kyttliittymn voidaan tmn metodin avulla list tieto uusista
    saapuneista viesteist.
    
    @return tieto siit, onko kyseiselle kyttjlle uusia viestej
    
    [ei kytss tss toteutuksessa]
    */
    /*
    public boolean hasPendingMessages(User user){
        
        // pendingMessages.get voi palauttaa true, false tai null.
        
        if (((Boolean) pendingMessages.get(user)).booleanValue())     
            return true;
        else
            return false;
    }
    */

    /**
    Palauttaa jrjestelmn ainoan WebClientHandlerin
    @return jrjestelmn ainoa WebClientHandler -olio
    */
    public static synchronized WebClientHandler getInstance(){
        if (WebClientHandler.webClientHandler == null){
            WebClientHandler.webClientHandler = new WebClientHandler();    
        }            
        return (WebClientHandler.webClientHandler);    
    }
       
}
