/*
Tiedosto: ActionEvent.java
Luokat:   ActionEvent

Tekij:   Olli Pettay
Luonti:   17.11.2002


Muutokset:
  17.11.2002 Olli Pettay  
              Luokan luonti
  25.11.2002 Olli Pettay
              MessageEvent->ActionEvent
  03.12.2002 Olli Pettay
              Koodi ja replace-metodien poisto. (Ne voidaan toteuttaa
              muiden metodien avulla.)
*/


package converge.kernel;

import java.util.*;

/**
*ActionEvent-olio annetaan sntjen ja viestin antamisen yhteydess
*Droolsille.
*/
public class ActionEvent {
  
  private HashMap hash = new HashMap();
  
  /**
  *Luodaan uusi ActionEvent
  */
  public ActionEvent(){}
  
  /**
  *Kopiokonstruktori
  *@param event kopioitava ActionEvent-olio
  */
  public ActionEvent(ActionEvent event){
    if (event != null) {
      this.hash = new HashMap();
      HashMap h  = event.getEvents();
      Set keys = h.keySet();
      Iterator it = keys.iterator();
      while (it.hasNext()) {
        String key = (String) it.next();
        this.hash.put(key, ((HashSet)h.get(key)).clone());
      } 
    }
  }
  
  /*Kyll avaimet ja arvot voivat olla Stringej, koska avaimet ovat yksiksitteisi ja
    arvot saadaan suoraan kyttliittymst.
  */
  
  /**
  *Listn avaimelle uusi arvo.
  *Tmn metodin kutsu ei poista vanhaa arvoa.
  *
  *@param key Avain
  *@param uusi arvo
  */
  public void addEvent(String key, String value){
    Set values = (Set)this.hash.get(key);
    if (values != null)
      values.add(value);
    else {
      values = new HashSet();
      values.add(value);
      this.hash.put(key, values);
    }
  }
  
  
  /**
  *Poistetaan avaimen kaikki arvot
  *
  *@param key avain
  */
  public void deleteEvent(String key){
    this.hash.remove(key);
  }
  
  /**
  *Poistetaan avaimen tietty arvo
  *
  *@param key Avain
  *@param oldvalue Poistettava arvo
  */
  public void deleteEvent(String key, String oldvalue) {
    Set values = (Set)this.hash.get(key);
    if (values != null)
      values.remove(oldvalue);
  }

  /**
  *Palautetaan hajautustaulu, jossa avaimina tapahtumien avaimet ja
  *arvoina Set-tyyppiset tietorakenteet, joihin talletettu arvot String-muotoisina.
  */
  public HashMap getEvents(){
    return this.hash;
  }
  
  
  
  public static void main(String[] args) {
    ActionEvent a = new ActionEvent();
    a.addEvent("name", "value");
    a.addEvent("name", "value2");
    a.addEvent("name", "value3");
    a.addEvent("name", "value4");
    a.addEvent("name", "value");
    a.addEvent("name2", "value2");
    a.addEvent("name3", "value3");
    ActionEvent a2 = new ActionEvent(a);
    a.addEvent("A", "A");
    a.addEvent("name", "name5");
    a2.addEvent("A2", "A2");
    printEvent(a);
    System.err.println();
    printEvent(a2);
  
  }
  
  protected static void printEvent(ActionEvent ae){
    Set keys = ae.getEvents().keySet();
    Iterator ki = keys.iterator();
    while (ki.hasNext()) {
      String key = (String) ki.next();
      Set keyvalues = (Set)ae.getEvents().get(key);
      Iterator vi = keyvalues.iterator();
        System.err.println("Key: " + key);
      while (vi.hasNext()) {
        String value = (String)vi.next();
        System.err.println("Value: " + value);
      }
      
    }
  }
}
