/*

Tiedosto   : ActionInterface.java

         
Tekij     : Olli Pettay
Luonti pvm : 25.11.2002


Muutokset :

25.11.2002 Olli Pettay
           Luotu
07.12.2002 Mikko Hiipakka
           Tarkistettu


*/


package converge.kernel;

import org.w3c.dom.*;
/**
 *Rajapinta toimintojen mritykselle.
 *
*/
public interface ActionInterface {
  
  /**
   * Luokan tietosisllksi annettava arvotieto
   * 
   * @param target Olio, joka on toiminnon kohteena,
   * @param values Toteutusluokan toimintaa ohjaavaa tietoa esim. tietokantakyselyj
   * @return Varmistus siit, ett onko ilmentym onnistuttu alustamaan toimintakuntoon
  */
  public boolean setValue(Object target, String[] values);
  /**
  * Suoritetaan luokan toiminto
  * @param action Mritetn mik luokan tukemista toiminnoista suoritetaan. 
  * SetValue-metodissa asetetut toimintaa ohjaavista tiedoista kytetn vain 
  * ymmretyt arvot
  */
  public void doAction( String action );
  /**
   * Luettelo attribuuttien nimist, joiden toteutuksen luokka tarjoaa
   * @return Attribuuttien nimet String-taulukossa
  */
  public String[] supportedActions();
  
  /**
   * Toteutusluokan tarjoaman palvelun,kytn ja toimminnan selvsanainen kuvaus.
  */
  public String getDescription();
  
  
  /**
  *Tukeeko olio ajastetuissa sntj
  */
  public boolean supportsScheduledRule(String name);
  
  /**
  *Tukeeko olio tavallisia sntj
  */
  public boolean supportsRule(String name);
}
