package converge.kernel;

import org.w3c.dom.*;

/**
* Tm luokka kuvaa snniss esiintyvi loogisia operaattoreja AND ja OR.
*/
public class ConditionalOperator implements XMLContentInterface{
  private String op;
  public ConditionalOperator(){}
  public ConditionalOperator(String op) {
    this.op = op.toUpperCase();
  }

  /**
  *Palautetaan operaattori Java-koodina.
  *
  *@return joko && tai ||
  */
  public String getOp() {
    if (this.op.equals("OR"))
      return "||";
    return "&&";
  }
  
  /**
  *Operaattorin tyyppi
  *
  *@return palautetaan joo AND tai OR
  */
  public String getType() {
    if (this.op.equals("OR"))
      return "OR";
    return "AND";
  }
  
  
  /**
  *Luodaan XML.
  */
  public void createXML(Node par){
    Element parent = (Element)par;
    Document dom = parent.getOwnerDocument();
    Element el = dom.createElement("conditionaloperator");
    el.setAttribute("type", this.op);
    parent.appendChild(el);
  }
  
  
  /**
  *Ladataan XML.
  */
  public boolean loadXML(Node cont){
    Element content = (Element)cont;
    Document dom = cont.getOwnerDocument();
    if (!content.getTagName().equals("conditionaloperator"))
      return false;
    this.op = content.getAttribute("type");
    return true;
  }
}
