/*
Tiedosto: Contact.java
Luokat:   Contact

Tekij:   Olli Pettay
Luonti:   20.11.2002

Muutokset:
  20.11.2002  Olli Pettay
              Luokan luonti
  

*/


package converge.kernel;
import java.util.*;
import org.w3c.dom.*;
/**
*Contact-olioissa silytetn kontaktitietoja avain-arvo -pareina.
*
*/
public class Contact implements XMLContentInterface{
  private HashMap props;
  private String name;
  
  public Contact(String name){
    this.props = new HashMap();
    this.name = name;
  }
  public Contact(){
    this.props = new HashMap();
  }
  
/**
*@return palautetaan nimi
*/
  public String getName() {
    return this.name;
  }

/**
*Arvon palautus.
*
*@param key avain, johon liitetty arvo palautetaan
*/
  public String get(String key){
    return (String)props.get(key);
  }

/**
*Asetetaan arvo.
*
*@param key avain
*@param value arvo
*/
  public void set(String key, String value) {
    props.put(key, value);
  }

/**
*Kaikkien avain-arvo-parien avaimet.
*/
  public String[] getKeys(){
    return (String[])this.props.keySet().toArray(new String[this.props.size()]);
  }
  
/**
*Ladataan XML.
*/
  public boolean loadXML(Node cont) {
    Element root = (Element) cont;
    if (!root.getTagName().equals("contact"))
      return false;
    this.name = root.getAttribute("name");
    Element child = (Element)root.getFirstChild();
    while (child != null) {
      child.normalize();
      this.set(child.getAttribute("name"), ((Text)child.getFirstChild()).getData());
      child = (Element) child.getNextSibling();
    }
    return true;
  }

/**
*Luodaan XML.
*/
  public void createXML(Node par) {
    Document dom = par.getOwnerDocument();
    Element el = dom.createElement("contact");
    el.setAttribute("name", this.name);
    Set keys = props.keySet();
    Iterator it = keys.iterator();
    while(it.hasNext()) {
      String key = (String)it.next();
      String value = (String)props.get(key);
      Element child = dom.createElement("item");
      child.setAttribute("name", key);
      Text data = dom.createTextNode(value);
      child.appendChild(data);
      el.appendChild(child);
    }
    par.appendChild(el);
  }
}
