/*

Tiedosto   : ContextModelHandler.java
Luokat     : ContextModelHandler

         
Tekij     : Mikko Hiipakka
Luonti pvm : 17.11.2002


Muutokset :

17.11.2002 Mikko Hiipakka
           Luokan rakenne luotu ja pseudokoodilla suunniteltu toimintaa
07.12.2002 Mikko Hiipakka
           Luokan toiminta rakennettu

*/


package converge.kernel;
import converge.service.Message;

/**
 * Luokka tarjoaa palvelun, jonka avulla jrjestelmn ytimen ksiteltvksi 
 * voidaan tuoda uusia viestej siten, ett niiden ksittely suoritetaan 
 * omissa sikeiss. Tllin uuden viestin tuominen on mahdollista milloin 
 * tahansa.
*/
public class ContextModelHandler {

  /**
   * Synkronoitu metodi viestien tuomiseen ytimen ksittelyyn 
   * @param msg Message 
  */
  public static synchronized void incomingMessage( Message msg ) {
    if(msg.getUser() == null)
        return;
    Process tmp = new Process( msg );
    tmp.start();
  }  
  
  //DEBUG***********************************************************************  
  public static void main(String[] args){
    User u = new User("t", "t");
    Message ms = new Message(u, null);
    ContextModelHandler.incomingMessage( ms );
    System.out.println("CONTEXTMODELHADLER-main : messageID : " + ms.getMessageID());
  }
  //DEBUG***********************************************************************  
}

class Process extends Thread {  
  private Message msg;
  private User user;
  public Process(Message m ){
    msg = m;
    user = msg.getUser();
  }
  
  public void run() {
      // Suojataan user-olio mahdollisilta muutoksilta ksittelyn ajaksi
      if(this.user.readLock( this )) {
        Log.output("ContextModelHandler").println("User " + this.user.getName() + " readLocked");
        try {
        // Kydn kaikki kyttjn kontekstimallit lpi
        ContextModel[] contModels = this.user.getContextModels();
        if ( contModels != null )
          for ( int i=0; i < contModels.length; i++ ){	
            contModels[i].startProcessing( this.msg );
          }
        ProfileHandler ph = new ProfileHandler( this.msg );
        ph.startProcessing();
        }catch (Exception e) {
          Log.stack(e);
        }
        // Vapautetaan user-olio
        this.user.releaseLock( this );
        Log.output("ContextModelHandler").println("User " + this.user.getName() + " released");
      }
  }
}



