package converge.kernel;

/*
Tiedosto: Crypt.java
Luokat:   Crypt

Tekij:   Olli Pettay
Luonti:   20.11.2002

Muutokset:
20.11.2002 Olli Pettay
           Luokan luonti

*/

import javax.crypto.spec.*;
import javax.crypto.*;


/**
*Tm luokka sislt salaukseen tarvittavia metodeja.
*
*
*
*/
public class Crypt{
  // Salt
  private static byte[] salt = {
        (byte)0xc7, (byte)0x73, (byte)0x21, (byte)0x8c,
        (byte)0x7e, (byte)0xc8, (byte)0xee, (byte)0x99
    };
  
  // Iteration count
  private static int count = 20;
  
  /**
  *Salataan salasanan perusteella dataa.
  *@param pw salasana
  *@param data salattava data
  *@return Palauttaa base64-muotoon muutetun salatun datan
  */
  public static String encode(String pw, byte[] data) {
    try {
    PBEKeySpec pbeKeySpec;
    PBEParameterSpec pbeParamSpec;
    SecretKeyFactory keyFac;
    byte[] password = pw.getBytes();

    // Create PBE parameter set
    pbeParamSpec = new PBEParameterSpec(salt, count);
    
    pbeKeySpec = new PBEKeySpec(pw.toCharArray());
    keyFac = SecretKeyFactory.getInstance("PBEWithMD5AndDES");
    SecretKey pbeKey = keyFac.generateSecret(pbeKeySpec);
    
    // Create PBE Cipher
    Cipher pbeCipher = Cipher.getInstance("PBEWithMD5AndDES");
    // Initialize PBE Cipher with key and parameters
    pbeCipher.init(Cipher.ENCRYPT_MODE, pbeKey, pbeParamSpec);
    byte[] crypted = pbeCipher.doFinal(data);
    return Base64.encodeBytes(crypted);
    }catch(Exception e) {return null;}
  }
  
  /**
  *Purkaa encode-metodin salauksen
  *@param pw Salasana
  *@param crypted salattu data String-muotoisena
  */
  public static String decode(String pw, String crypted) {
    try {
    PBEKeySpec pbeKeySpec;
    PBEParameterSpec pbeParamSpec;
    SecretKeyFactory keyFac;
    byte[] password = pw.getBytes();
    byte[] cryptedbytes = Base64.decode(crypted);

    // Create PBE parameter set
    pbeParamSpec = new PBEParameterSpec(salt, count);
    
    pbeKeySpec = new PBEKeySpec(pw.toCharArray());
    keyFac = SecretKeyFactory.getInstance("PBEWithMD5AndDES");
    SecretKey pbeKey = keyFac.generateSecret(pbeKeySpec);
    
    // Create PBE Cipher
    Cipher pbeCipher = Cipher.getInstance("PBEWithMD5AndDES");
    // Initialize PBE Cipher with key and parameters
    pbeCipher.init(Cipher.DECRYPT_MODE, pbeKey, pbeParamSpec);
    byte[] decrypted = pbeCipher.doFinal(cryptedbytes);
    return new String(decrypted);
    }catch(Exception e) {return null;}
  }
  
  /**
  *Mikli salasana on salattu itselln, voidaan tll
  *metodilla testata onko salasana oikea.
  *@param password Salaamaton salasana
  *@param crypted Salattu salasana
  */
  //Onko tss mitn jrke? Ei ole ainakaan kovin turvallinen ratkaisu,
  //mutta riittneen Convergessa?
  public static boolean isPassword(String password, String crypted) {
    if (password == null || crypted == null) return false;
    String de = decode(password, crypted);
    if (de != null) return de.equals(password);
    return false;
  }
    
}
