/*
Tiedosto: Log.java
Luokat:   Log

Tekij:   Olli Pettay
Luonti:   23.11.2002

Muutokset:
  23.11.2002  Luokan luonti

  
TODO: ksittele virheet
*/


package converge.kernel;
import java.io.*;
import java.util.*;

/**
*Jrjestelmn lokitietojen tallennus.
*/
public class Log{
  //For convenience
  public static PrintStream out;
  //For convenience
  public static PrintStream err;
  private static String dir = "logs/";
  private static String postfix = ".log";
  private static Map pws = Collections.synchronizedMap(new HashMap());
  
  static {
    try { 
      out = new PrintStream(new FileOutputStream(dir + "out" + Log.postfix));
      err = new PrintStream(new FileOutputStream(dir + "err" + Log.postfix));
    }
    catch(Exception e){
    err = System.err;
    out = System.out;
    }
  }
  
  /**
  *Palautetaan nimen perusteella PrintStream-olio, jonka
  *avulla lokitiedostoon voi kirjoittaa.
  *
  *Nimen ensimmisell kutsukerralla luodaan uusi PrintStream olio, 
  *jonka tulostus ohjataa logs/nimi.log -tiedostoon.
  *
  */
  public static synchronized PrintStream output(String name) {
    if (name.equals("err")) return err;
    if (name.equals("out")) return out;
    if (!pws.containsKey(name)) 
      try{
        pws.put(name, new PrintStream(new FileOutputStream(dir + name + Log.postfix)));
      }
      catch(Exception e){
        e.printStackTrace(System.err);
      }
    return (PrintStream) pws.get(name);
  }
  
  /**
  *Kutsuu poikkeuksen printStackTrace-metodia ja tulostaa vastaukset
  *Log.err -virtaan.
  */
  public static synchronized void stack(Exception e) {
    e.printStackTrace(Log.err);
  }
  
  
  /**
  *Kutsuu poikkeuksen printStackTrace-metodia ja tulostaa vastaukset
  *Log.output(output) -virtaan.
  */
  public static synchronized void stack(Exception e, String output) {
    e.printStackTrace(Log.output(output));
  }
  
  /**
  *Kutsuu poikkeuksen printStackTrace-metodia ja tulostaa vastaukset
  *output -virtaan.
  */
  public static synchronized void stack(Exception e, PrintStream output) {
    e.printStackTrace(output);
  }
  
  /**
  *Suoritetaan flush kaikille PrintStream-olioille.
  */
  public synchronized static void flush(){
    err.flush();
    out.flush();
    Set keys = pws.keySet();
    Iterator it = keys.iterator();
    while(it.hasNext())
      ((PrintStream)pws.get((String)it.next())).flush();
  } 
  
}
