package converge.kernel;

import org.w3c.dom.*;

/**
*Sntjen ehtojen ksittely.
*Tmn luokan ilmentym pit sislln tiedon
*attribuutin nimest, halutusta arvosta ja
*attribuutin ja arvon vertailuun kytettvst
*operaattorista.
*
*
*/
public class Triple implements XMLContentInterface{
  private String name;
  private String value;
  private String expression;
  public Triple(){}
  public Triple(String name, String value, String expression) {
    this.name = name;
    this.value = value;
    this.expression = expression;
  }
  
  /**
  *Palautetaan nimi.
  */
  public String getName() {
    return this.name;
  }
  
  /**
  *Palautetaan arvo.
  */
  public String getValue() {
    return this.value;
  }
  
  /**
  *Palautetaan operaattori
  */
  public String getExpression() {
    return this.expression;
  }
  
  /**
  *Luodaan Java-koodia
  */
  public String makeCode(String objectname, String methodname) {
    return "\n" + objectname +"." + methodname +"(\"" + this.name + "\").compare(\"" + this.expression + "\", \"" + this.value + "\")\n";  
  }  
  
  
  /**
  *Luodaan XML
  */
  public void createXML(Node par){
    Element parent = (Element)par;
    Document dom = parent.getOwnerDocument();
    Element el = dom.createElement("triple");
    el.setAttribute("name", this.name);
    el.setAttribute("value", this.value);
    el.setAttribute("expression", this.expression);
    parent.appendChild(el);
    
  }
  
  
  /**
  *Ladataan XML.
  */
  public boolean loadXML(Node cont){
    Element content = (Element)cont;
    Document dom = cont.getOwnerDocument();
    if (!content.getTagName().equals("triple"))
      return false;
    this.name = content.getAttribute("name");
    this.value = content.getAttribute("value");
    this.expression = content.getAttribute("expression");
    return true;
  }
}
