package converge.kernel;
/*

Tiedosto   : XMLUtil.java
Luokat     : XMLUtil

         
Tekij     : Mikko Hiipakka
Luonti pvm : 19.11.2002


Muutokset :

19.11.2002 Mikko Hiipakka
           Luokan rakenne luotu
10.12.2002 Mikko Hiipakka
           outputPrinting listty
*/




import java.io.*;
import org.w3c.dom.*;
import javax.xml.parsers.*;
import javax.xml.transform.*;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;


/**
 * XML:n ksittely helpottavia staattisia metodeja.
*/
public class XMLUtil{

  public static final String NS_DROOLS = "http://drools.org/rules";
  public static final String NS_DROOLS_JAVA = "http://drools.org/semantics/java";
  
  
  /**
   * Rakentaa tyhjn DOM Documentin
   * @return org.w3c.dom.Document rajapinnan toteuttavan ilmentymn
  */
  public static Document newXMLDocument(){
    Document dom = null;;
    try {
    dom =  DocumentBuilderFactory.newInstance().newDocumentBuilder().newDocument();
    }catch(Exception ex){
       Log.output("XMLUtil").println("Dom Documentin luonti eponnistui");
       Log.output("XMLUtil").println( ex.getMessage() );
       ex.printStackTrace( Log.output("XMLUtil") );
       return null;
    }
    return dom;
  }
  
  
  /**
  * Rakentaa Drools-sntksittelijlle sopivan dokumentin,
  * joka ei sisll yhtn snt.
  */
  public static Document newDroolsDocument(){
    Document dom = newXMLDocument();
    Element el = dom.createElementNS(NS_DROOLS ,"rules");
    el.setAttribute("xmlns", NS_DROOLS);
    el.setAttribute("xmlns:java", NS_DROOLS_JAVA);
    Element el2 = dom.createElementNS(NS_DROOLS,"semantics");
    el2.setAttribute("module", "org.drools.semantics.java");
    el.appendChild(el2);
    el2 = dom.createElementNS(NS_DROOLS, "rule-set");
    el2.setAttribute("name", "A_CONVERGE_RULE_SET");
    el.appendChild(el2);
    dom.appendChild(el);
    
    return dom;
  }
  
  
  /**
  * Tulostetaan XML: OutputStreamiin.
  * @param dom Dom documentti, joka halutaan tulostettavan
  * @param output OutputStream, johon tulos halutaan kirjoitettavaksi
  */
  public static void outputPrinting( Document dom, OutputStream output ){
     DOMSource source = null;
     StreamResult result = null;
     if ( dom == null)
       return;
     else
       source = new DOMSource( dom );
     if (output == null)
       result = new StreamResult( System.out );
     else
       result = new StreamResult( output );
     try{
       TransformerFactory tFactory = TransformerFactory.newInstance();
       Transformer tr = tFactory.newTransformer();
       tr.setOutputProperty( OutputKeys.INDENT, "yes" );
       tr.transform( source, result );
     }catch( Exception e ){
       //DEBUG
       System.out.println("DOM printtaus eponnistui");
       //DEBUG
       Log.output("XMLUtil").println("DOM printtaus eponnistui");
       Log.output("XMLUtil").println( e.getMessage() );
       e.printStackTrace( Log.output("XMLUtil") );
     }
  } 
}
