/*

Tiedosto   : ActionIncomingMessage.java

         
Tekij     : Olli Pettay
Luonti pvm : 10.12.2002


Muutokset :

10.12.2002 Olli Pettay
           Toimintaa hahmoteltu 


*/


package converge.kernel.actionImplementations;

import converge.kernel.ActionInterface;
import converge.kernel.*;
import converge.service.*;
import org.w3c.dom.*;
import java.util.*;

/**
 *Tm ActionInterface-rajapinnan toteutus liitt
 *jrjestelmn sisn tulleen viestin johonkin nkymn.
*/
public class ActionIncomingMessage implements ActionInterface {
  
  private static String[] supports = { "Set-To-View"};
  private static String description = "Viestin tallennus";
  private Message msg;
  private String[] conf;
  
  /**
  *Asetetaan toiminnon arvot.
  *
  *@param givenTarget toiminnon suorittaja
  *@param values parametrit toiminnolle
  */
  public boolean setValue(Object givenTarget, String[] values){
    if (!(givenTarget instanceof Message) || givenTarget == null)
      return false;
    this.msg = (Message)givenTarget;
    this.conf = values;
    return true;
  }
  
  /**
   * Suoritetaan toiminto.
   *
   *
   * @param action suoritettavan toiminnon nimi
   * @see setValue
  */ 
  public void doAction( String action ) {
    if ( action.equals( "Set-To-View" ) ){
      System.out.println("TLL OLLAAN");
      //Ensimminen kantaan, muut nkymiin
      if (conf.length > 0) {
        ViewMonitor.setMessageToView(this.msg, conf[0]);
        for (int i = 1; i < conf.length; ++i)
          ViewMonitor.setMessageToView(this.msg.getUser(), 
                                       this.msg.getMessageID(),
                                       conf[i]);
      }
    }
  }
  /**
  *Palautetaan tmn luokan toteuttamien toimintojen nimet.
  */
  public String[] supportedActions(){
    return ActionIncomingMessage.supports;
  }
  
  /**
  *Palautetaan luokan selkokielinen kuvaus.
  */
  public String getDescription() {
    return ActionIncomingMessage.description;
  }
  /**
  *Voidaanko toimintoa kytt ajastettujen sntjen yhteydess.
  *
  *@param name toiminnon nimi
  */
  public boolean supportsScheduledRule( String name ){
    return false;
  }

  /**
  *Voidaanko toimintoa kytt tavallisten sntjen yhteydess.
  *
  *@param name toiminnon nimi
  */
  public boolean supportsRule( String name ){
    return "Set-To-View".equals(name);
  }
}
