/*
Tiedosto: StreamDownloader.java
Luokat:   StreamDownloader

Tekij:   Anssi Johansson
Luonti:   13.12.2002

Muutokset:
  13.12.2002  Luokan luonti

*/
package converge.service;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.InputStream;
import java.io.OutputStream;
import converge.kernel.Log;

/**
* Hakee annetusta tiedostokahvasta tietoa kunnes tiedon kulku katkeaa.
*/

public class StreamDownloader
extends Thread {
    BufferedReader bufr;
    BufferedWriter bufw;
    InputStreamReader isr;
    OutputStreamWriter osw;
    InputStream is;
    OutputStream os;

    /**
    * Oletuskonstruktori.
    *
    * @param bufr BufferedReader
    * @param bufw BufferedWriter
    * @param isr  InputStreamReader
    * @param osw  OutputStreamWriter
    * @param is   InputStream
    * @param os   OutputStream
    */
    public StreamDownloader(BufferedReader bufr, BufferedWriter bufw,
                            InputStreamReader isr, OutputStreamWriter osw,
                            InputStream is, OutputStream os) {
        this.bufr=bufr;
        this.bufw=bufw;
        this.isr=isr;
        this.osw=osw;
        this.is=is;
        this.os=os;
    }

    /**
    * Kynnist sikeen liitetiedoston hakemiseksi.
    */
    public void run() {
        try {
            final int bufsize = 16*1024;
            int readbytes = 0;
            char[] buffer = new char[bufsize];

            while((readbytes = bufr.read(buffer,0,bufsize))>0)
                bufw.write(buffer,0,readbytes);

            bufr.close();
            isr.close();
            is.close();

            bufw.flush();
            osw.flush();
            os.flush();
            bufw.close();
            osw.close();
            os.close();

        } catch(Exception e) {
            System.out.println("StreamDownloader exception: " + e);
            Log.stack(e,"StreamDownloader");
        }
    }
}
