
import org.drools.RuleBase;
import org.drools.WorkingMemory;
import org.drools.TransactionalWorkingMemory;
import org.drools.DroolsException;
import org.drools.AssertionException;
import org.drools.rule.RuleSet;

import org.drools.io.RuleSetLoader;

import java.io.IOException;
import java.net.URL;
import java.util.List;
import java.util.Iterator;

import org.w3c.dom.*;
import javax.xml.parsers.*;

public class MessageRules
{
  public static void main(String[] args) {
    for (int i= 0 ; i < 1; ++i)
      testDrools();
  }
    public static void testDrools()
    {
        try
        {
            String str1 = "test";
            String str2 = "f";
            DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
            dbf.setNamespaceAware(true);
            dbf.setCoalescing(true);
            dbf.setIgnoringComments(true);
            DocumentBuilder db = dbf.newDocumentBuilder();
            Document msg = db.parse("Message.xml");
            ConvergeMessage cm = new ConvergeMessage(msg);
          
            Document msg2 = db.parse("Message2.xml");
            ConvergeMessage cm2 = new ConvergeMessage(msg2);
            // First, construct an empty RuleBase to be the
            // container for your rule logic.
            
            RuleBase ruleBase = new RuleBase();
            
            // Then, use the [org.drools.semantic.java.RuleLoader]
            // static method to load a rule-set from a local File.
            

            RuleSetLoader loader = new RuleSetLoader();

            URL url = MessageRules.class.getResource( "MessageRules.xml" );

            System.err.println( "loading: " + url );
            Compiler.disable();
            List ruleSets = loader.load( url );
            Compiler.enable();

            Iterator ruleSetIter = ruleSets.iterator();
            RuleSet  eachRuleSet = null;

            while ( ruleSetIter.hasNext() )
            {
                eachRuleSet = (RuleSet) ruleSetIter.next();

                ruleBase.addRuleSet( eachRuleSet );
            }

            // Create a [org.drools.WorkingMemory] to be the
            // container for your facts
            
            TransactionalWorkingMemory workingMemory = ruleBase.createTransactionalWorkingMemory();

            try
            {
               System.err.println("Add source object.");
               for(int i = 0 ; i < 1; ++i) 
               {
               workingMemory.assertObject(cm);
               workingMemory.assertObject(cm2);
               workingMemory.assertObject(str1);
               workingMemory.assertObject(str2);
               try{
               workingMemory.commit();
               }catch(Exception e) {System.err.println("Error, cannot commit!");}
               }
               /*for (int i = 0; i < 1000; ++i) {
               workingMemory.retractObject(cm);
               workingMemory.assertObject(cm2);
               System.err.println("Add source object (again) " + i);
               workingMemory.assertObject(cm);
               }*/
            }
            catch (AssertionException e)
            {
                e.printStackTrace();
            }
        }
        catch (DroolsException e)
        {
            e.printStackTrace();
        }
        catch (IOException e)
        {
            e.printStackTrace();
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }
    }
}


