/*
Tiedosto: Main.java
Luokat:   

Tekij:   Tea Silander
Luonti:   5.12.2002


Muutokset:
  5.12.2002 Tea
              Luokan luonti
  11.12.2002 Olli
              Linkki nkymn
  18.12.2002 Joni
              Kommentointia, pieni muutoksia                    
*/

package webcore;

import converge.kernel.*;
import converge.clientmanager.*;
import java.io.*;
import java.util.*;
import webcore.webserver.*;

/**
Sisnkirjautumisen jlkeinen etusivu, jolla on lista kyttjn nkymist.

*/
public class Main implements WebRequestable {

    static ClientManager cm = ClientManager.getInstance();
    User user;
    long receivedSessionId;
    boolean hasCookie;
    boolean emergencyExit;
    String[] viewNames = null;
    

    /**
    Ksitelln HTTP-pyynt.
    
    @param httpRequest ksiteltv HTTP-pyynt
    */
    
    public void processRequest(HTTPRequest httpRequest) {
        PrintWriter pw = null;
        
        // aluksi:  haetaan cookie, sen perusteella user
        
        String tmpCookie = httpRequest.getCookie("session-id");
        if (tmpCookie != null){
            hasCookie = true;
            receivedSessionId = Long.parseLong(tmpCookie);
        }
        user = cm.getUserBySessionId(receivedSessionId);
        
        // jos ei ole validia user-oliota,
        // loggaudutaan ulos virheilmoituksen kera
        if (user == null)            
            emergencyExit = true;
                
        // haetaan muuttujiin tarvittavat tiedot
        
        if(!emergencyExit && !(user instanceof Group)){
            
            viewNames = ViewMonitor.getViewNames(user);
            
        }
        
        try {
          pw = httpRequest.getPrintWriter();
          
          
      if (emergencyExit)
         HtmlUtils.printEmergencyExitPage(pw);
        
      else{
          pw.println(htmlHeader);
          pw.print(HtmlUtils.startPage("Main page"));
          pw.println("<BODY>");
          
          //  'navigaatiopalkki'
          HtmlUtils.printNavigationBar(pw);
          
          // Sivun otsikko ja kyttjnimi jolla on kirjauduttu jrjestelmn
            HtmlUtils.printPageInfo(pw, user.getName(), "Main page of the system");
          
          //pw.print("<h4>Main page of the system</h4>");
          
          
          if (viewNames != null && viewNames.length > 0){              
            pw.print("<p>List of views</p>");
            
            pw.print("<div class='viewlist'>\n\n");          
            //pw.println("<TABLE>");      
              for(int i=0; i<viewNames.length; i++){
                //tulostetaan nkymien otsikot            
                String name = viewNames[i];
                //pw.print("<TR><TD><A HREF='webcore.View?view=" + name +"'>" + name);
                //pw.print("</A></TD></TR>\n");
                pw.print("<A HREF='webcore.View?view=" + name +"'>" + name+"</a><br>\n");
              }
              //pw.println("</TABLE>");
              pw.println("</div>");
          }
          else{
              pw.print("<p>No views</p>");
          }
        
            //testausta varten:
            HtmlUtils.printTestingStuff(pw, httpRequest);
            
            // sivun loppu:
            HtmlUtils.printEndOfPage(pw);
      }
        }

        catch (Exception e) {
            e.printStackTrace(pw);
        }

        finally {
            try{httpRequest.close();}
                catch (java.io.IOException e2) {e2.printStackTrace(pw);}
        }
    }





}
