/*
Tiedosto: View.java
Luokat:   

Tekij:   Tea Silander
Luonti:   5.12.2002


Muutokset:
  5.12.2002 Tea
              Luokan luonti
  11.12.2002 Olli
              Nkymien viestien otsikot
  15.12.2002 Joni
              Siistimist, kommentointia, pieni muutoksia              
*/

package webcore;
import converge.kernel.*;
import converge.clientmanager.*;
import java.io.*;
import java.util.*;
import webcore.webserver.*;

/**
Yhden nkymn sislt, eli lista nkymn kuuluvista viestest.  
<br><br>

*/
public class View implements WebRequestable {
    static ClientManager cm = ClientManager.getInstance();
    User user;
    long receivedSessionId;
    boolean hasCookie;
    boolean emergencyExit;
    String viewName;             // ksiteltvn nkymn nimi
    converge.kernel.View view;   // ksiteltv nkym
    Header[] headers;            // nkymn viestien otsikkotiedot

    
// thn tullaan Main.java:n kautta, kun kyttj on valinnut nkymn.
//  toiminnallisuutta:
// -Nkymien viestien nyttminen
// -Yhden viestin lukeminen
// -Viestin poistaminen nkymst
// -Viestin poistaminen kaikista nkymist ja kannasta
// 
// + nihin liittyvien HTML-sivujen generointi
// 
// Nkymn viestien listaaminen:
// -Pyydetn ytimelt nkymn liittyvien viestien tunnukset getMessageIDs -metodilla
 


    
    /**
    Ksitelln HTTP-pyynt.
    
    @param httpRequest ksiteltv HTTP-pyynt
    */ 

    public void processRequest(HTTPRequest httpRequest) {
        
        PrintWriter pw = null;
        String tmpCookie = httpRequest.getCookie("session-id");
        if (tmpCookie != null){
            hasCookie = true;
            receivedSessionId = Long.parseLong(tmpCookie);
        }
        user = cm.getUserBySessionId(receivedSessionId);
        
        // jos ei ole validia user-oliota,
        // loggaudutaan ulos virheilmoituksen kera
        if (user == null)            
            emergencyExit = true;
        else if (httpRequest.getFormVar("delete-view") != null)
      ViewMonitor.deleteView(user, httpRequest.getFormVar("delete-view"));
        else {                        
            // haetaan nkymn nimi ja viite view-olioon  
            // asetetaan muuttujien arvoiksi
            
            viewName = httpRequest.getFormVar("view");
            view = ViewMonitor.getView(user, viewName);                        
            
            // viestien poistaminen nkymst    
            
            String msgToBeDeleted = httpRequest.getFormVar("delete-message");        
            if (msgToBeDeleted != null && viewName != null){ 
                ViewMonitor.deleteMessageFromView(user, msgToBeDeleted, viewName);
                // nkymn pivitys tehdn nin:
                view = ViewMonitor.getView(user, viewName);   
            }            
            // haetaan viestien otsikkotiedot                            
            headers = view.getMessageHeaders();    
        }        

        
        
        
      try {
          
          pw = httpRequest.getPrintWriter();
          
          if (emergencyExit)
              HtmlUtils.printEmergencyExitPage(pw);
        
      else{
          pw.println(htmlHeader);
          pw.print(HtmlUtils.startPage("View '"+viewName+"'"));
          pw.println("<BODY>");

          // 'navigaatiopalkki'
          HtmlUtils.printNavigationBar(pw);
          pw.print("<p>Logged in as: <b>"+user.getName()+"</b></p>\n");
          
          // tulostetaan <table>, jossa on listattuna tmn nkymn sisltmt
          // viestit                     
        if (view != null) {
          pw.println("<H1><a title='Click to reload' class='plain' "
                      +"href='webcore.View?view="+viewName+"'>" + viewName +"</a></H1>");
                    if (headers.length == 0) {
            pw.println("<form method='post' action='webcore.View'>");
            pw.println("<input type='hidden' name='delete-view' value='" + viewName + "'>");
            pw.println("<input type='submit' name='delete view' value='delete view'><br>");
            pw.println("</form>");
          } else {
          pw.println("<TABLE class='messagelist'>");
          pw.println("<tr><td>FROM</td><td width='15'></td><td>SUBJECT</td>"
                      +"<td width='15'></td><td>DATE</td><td></td></tr>");                   
          if (headers != null) {
            for (int i = 0; i < headers.length; ++i) {
              String subj = headers[i].getSubject();
              if(subj == null || subj.equals(""))
                  subj = "(empty subject)";
              pw.println("<tr><td>" + headers[i].getSender() + "</td><td></td><td>"
                        +"<a href='webcore.Message?message="+headers[i].getId() +
                         "&view=" + viewName + "'>" + subj + "</a>" +
                         "</td><td></td><td>" + headers[i].getDate() +
                         "</td><td>");
              pw.println("<form method='post' action='webcore.View'>");
              pw.println("<input type=hidden name='delete-message' value='" + 
                          headers[i].getId() + "'>");
              pw.println("<input type=hidden name='view' value='" + viewName + "'>");
              pw.println("<input type=submit name='delete' value='delete'><br>");
              pw.println("</form>");
              pw.println("</td></tr>");
            }
          }
          pw.println("</TABLE>");
        }
        
      }

            //testausta varten:
            HtmlUtils.printTestingStuff(pw, httpRequest);
      }

        }
        catch (Exception e) {
            e.printStackTrace(pw);
        }
        finally {
            try{httpRequest.close();}
                catch (java.io.IOException e2) {e2.printStackTrace(pw);}
        }
      if (user != null)
          user.releaseLock(this);
    }



}
