package webcore.webserver;

import java.io.*;
import java.net.*;

/*****
 * Class which outputs HTML with a link to the same hostname/ip, but with
 * an https connection.
 */
public class SSLRedirector implements WebRequestable
{

    /***
     * processes the request by outputting HTML which will redirect the browser
     * to the https site with the same address.
     */
    public void processRequest(HTTPRequest request) throws Exception
    {
        PrintWriter pw = request.getPrintWriter();
        Socket s = request.getRequestSocket();
        String selfAddr = request.getHost();
        if (selfAddr == null)
        {
            InetAddress self = s.getLocalAddress();
            selfAddr = self.getHostAddress();
        }
        String secureLink = "<A HREF=\"https://" + selfAddr + "/\">";
        pw.println(htmlHeader);
        pw.println("<HTML>");
        pw.println("<HEAD>");
        pw.print("<META HTTP-EQUIV=\"REFRESH\" ");
        pw.print("CONTENT=\"0; URL=");
        pw.print("https://" + selfAddr);
        pw.print("\";>");
        pw.println("</HEAD>");
        pw.println("<TITLE>SSL Redirector Page</TITLE>");
        pw.println("<BODY BGCOLOR=FFFFFF><CENTER><H1>SSL Security Redirect</H1>");
        pw.println("<FONT SIZE=+1>");
        pw.println("<HR WIDTH=50>");
        pw.println("Your browser is being redirected to a secure site.");
        pw.println("<HR WIDTH=50>");
        pw.println("</FONT>");
        pw.println("<BR>If you are not automatically redirected:<BR>");
        pw.println(secureLink + "Click here to go..." + "</A>");
        pw.println("</BODY>");
        pw.println("</HTML>");
        pw.flush();
        pw.close();
    }
}
