package webcore.webserver;

import java.util.*;

/***
 * Event class for webserver events.  WebServerEvents are passed to
 * WebServerListeners when an HTTP request comes in, when an error occurs, and
 * when the WebServer is started or stopped.<p>
 * The WebServerEvent has an Arg property.  The Arg (argument) is a String
 * for stop and start events, an HTTPRequest for requested events, and an
 * Exception for minor error events.
 */
public class WebServerEvent extends EventObject
{
    private Object arg;

    public WebServerEvent(Object target)
    {
        super(target);
    }

    public WebServerEvent(Object target, Object arg)
    {
        super(target);
        this.arg = arg;
    }

    public String toString()
    {
        return super.toString() + " Arg: " + arg;
    }

    public Object getArg()
    {
        return arg;
    }

    public void setArg(Object agr)
    {
        this.arg = arg;
    }
}